CF-1016-G. Shorten the Array(异或字典树) · znzryb
## 思路讲解
处理这种任意组合问题怎么搞?不可能把每个组合都求一遍时,应该怎么办那?
哈哈,其实那就要跳脱出这个组合啦。
::: 错误的推论(异或计算没有保序性)
$A_i\ xor A_j ≥ k$ → $A_i≥k\ xorA_j$
:::
看了提示,用**异或字典树**做。
这是因为字典树共享前缀(假设位数高的为前缀)。
## AC代码
[https://codeforces.com/contest/2093/submission/315036163](https://codeforces.com/contest/2093/submission/315036163)
::: 源代码
```cpp
// Problem: G. Shorten the Array
// Contest: Codeforces - Codeforces Round 1016 (Div. 3)
// URL: https://codeforces.com/contest/2093/problem/G
// Memory Limit: 512 MB
// Time Limit: 2000 ms
// by znzryb
//
// Powered by CP Editor (https://cpeditor.org)
#include <bits/stdc++.h>
#define FOR(i, a, b) for (int i = (a); i <= (b); ++i)
#define ROF(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) x.begin(),x.end()
#define CLR(i,a) memset(i,a,sizeof(i))
#define fi first
#define se second
#define pb push_back
#define SZ(a) ((int) a.size())
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll,ll> pll;
typedef array<ll,3> arr;
typedef double DB;
typedef pair<DB,DB> pdd;
typedef pair<ll,bool> plb;
constexpr ll MAXN=static_cast<ll>(2e5)+10,INF=static_cast<ll>(5e18)+3;
ll N,K,T,A[MAXN];
struct Trie{
ll val /* ,digit=0 */ ,nxt0,nxt1;
// bool tag01=false; // tag01好像没有用,但也懒得删了,就当是方便调试
}tr[MAXN*35];
ll idx=0;
bool bitA[MAXN][35];
bool bitK[35];
inline void add(ll node,ll x,ll digit){
// 将数A[x]加入异或字典树
while(digit){
if(bitA[x][digit]){
if(tr[node].nxt1==0){
tr[node].nxt1=++idx;
node=idx;
tr[node].val=x;
// tr[node].tag01=true;
}else{
node=tr[node].nxt1;
tr[node].val=x;
}
}else{
if(tr[node].nxt0==0){
tr[node].nxt0=++idx;
node=idx;
tr[node].val=x;
// tr[node].tag01=false;
}else{
node=tr[node].nxt0;
tr[node].val=x;
}
}
--digit;
}
}
inline void init(){
idx=0;
FOR(i,0,N*33){
tr[i].val=INF;
// tr[i].digit=0;
tr[i].nxt0=0;
tr[i].nxt1=0;
// tr[i].tag01=false;
}
ll x=K;
ll ind=0;
while(x){
bitK[++ind]=x&1;
x>>=1;
}
for(ind+=1;ind<=33;++ind){
bitK[ind]=false;
}
}
ll query(ll node,ll x,ll digit){
if(!digit){ // 避免一些特殊情况,一般情况我用if else解决了
return INF;
}
ll res=INF;
if(tr[node].nxt1!=0){
if(!bitA[x][digit]){
if(bitK[digit]==0){ // 如果A这位为0,树这位为1,K这位为0,那么就大了!
res=min((ll)tr[tr[node].nxt1].val,res);
}else{ // 如果A这位为0,树这位为1,K这位为1,那么相等,继续向下找
if(digit==1) res=min(res,(ll)tr[tr[node].nxt1].val);
else res=min(res,query(tr[node].nxt1,x,digit-1));
}
}else{
if(bitK[digit]==0){ // 如果A这位为1,树这位为1,K这位为0,那么就大了!
if(digit==1) res=min((ll)tr[tr[node].nxt1].val,res);
else res=min(query(tr[node].nxt1,x,digit-1),res);
}
// 如果A这位为1,树这位为1,K这位为1,那么就小了
}
}
if(tr[node].nxt0!=0){
if(!bitA[x][digit]){
if(bitK[digit]==0){ // 如果A这位为0,树这位为0,K这位为0,那么就向下找
if(digit==1) res=min((ll)tr[tr[node].nxt0].val,res);
else res=min(query(tr[node].nxt0,x,digit-1),res);
}
// 如果A这位为0,树这位为0,K这位为1,那么小了,就不用找了
}else{
if(bitK[digit]==0){ // 如果A这位为1,树这位为0,K这位为0,那么就大了!
res=min((ll)tr[tr[node].nxt0].val,res);
}else{ // 如果A这位为1,树这位为0,K这位为1,那么就相等了,继续找
if(digit==1) res=min((ll)tr[tr[node].nxt0].val,res);
else res=min(res,query(tr[node].nxt0,x,digit-1));
}
}
}
return res;
}
inline void solve(){
cin>>N>>K;
// 初始化异或线段树
init();
FOR(i,1,N){
cin>>A[i];
ll x=A[i];
ll ind=0;
while(x){
bitA[i][++ind]=x&1;
x>>=1;
}
for(ind+=1;ind<=33;++ind){
bitA[i][ind]=false;
}
}
if(K==0){
cout<<1<<"\n";
return;
}
add(0,N,33);
ll ans=INF;
ROF(i,N-1,1){
ans=min(ans,query(0,i,33)-i+1);
add(0,i,33);
}
if(abs(ans-INF)<1e18){
cout<<-1<<"\n";
}else{
cout<<ans<<'\n';
}
// #ifdef LOCAL
// FOR(i,1,N){
// FOR(j,1,33){
// cerr<<bitA[i][j];
// }
// cerr<<"\n";
// }
// cerr<<"\n";
// FOR(i,1,33){
// cerr<<bitK[i];
// }
// cerr<<"\n";
// FOR(i,0,N*33){
// cerr<<"ind:"<<i<<" "<<tr[i].nxt0<<" "<<tr[i].nxt1<<" "<<tr[i].tag01<<" "<<tr[i].val<<"\n";
// }
// cerr<<"\n";
// #endif
// #ifdef LOCAL
// cerr << sizeof(tr)/1024/1024 << '\n';
// #endif
}
int main()
{
ios::sync_with_stdio(false);
cin.tie(0);cout.tie(0);
cin>>T;
while(T--){
solve();
}
// solve();
return 0;
}
/*
AC
https://codeforces.com/contest/2093/submission/315036163
*/
```
:::
## 心路历程(WA,TLE,MLE……)
CE
这里的val值最好不要事先写上去,反正codeforces的编译器初始化空间大概是33MB左右,太小了。所以这种结构体可以不赋值。
```cpp
struct Trie{
int val=INF /* ,digit=0 */ ,nxt0=0,nxt1=0;
// bool tag01=false; // tag01好像没有用,但也懒得删了,就当是方便调试
}tr[MAXN*14];
```